package no.miles.mpl.plugins;

import java.util.Date;

import no.miles.mpl.plugins.jira.exception.RemoteAuthenticationException;
import no.miles.mpl.plugins.jira.exception.RemoteException;
import no.miles.mpl.plugins.jira.exception.RemotePermissionException;

public interface JiraSoapServiceExtension {


    String login(String username, String password) throws RemoteException, RemoteAuthenticationException;

    boolean logout(String token);
	
	/**
	 * 
	 * @param token - The login token
	 * @param projectKeys - Keys for the projects to include
	 * @return
	 * @throws RemotePermissionException 
	 * @throws RemoteAuthenticationException 
	 * @throws RemoteException 
	 */
	public String[] getIssueKeysWithProject(String token, String[] projectKeys) throws RemoteAuthenticationException, RemotePermissionException, RemoteException;

	/**
	 * Shouldn't this be RemoteIssue??
	 * @param token - The login token
	 * @param projectKeys - Keys for the projects to include
	 * @param changedSince - The date which the issues have been updated since
	 * @return
	 * @throws RemotePermissionException 
	 * @throws RemoteAuthenticationException 
	 * @throws RemoteException 
	 */
	public String[] getUpdatedIssueKeysWithProject(String token, String[] projectKeys, Date changedSince) throws RemoteAuthenticationException, RemotePermissionException, RemoteException;

	
}
