package no.miles.mpl.plugins;

import java.util.Date;

import no.miles.mpl.plugins.jira.auth.TokenManager;
import no.miles.mpl.plugins.jira.exception.RemoteAuthenticationException;
import no.miles.mpl.plugins.jira.exception.RemoteException;

import com.opensymphony.user.User;

public class JiraSoapServiceExtensionImpl implements JiraSoapServiceExtension {


	private TokenManager tokenManager;
	private SearchServiceExtension searchServiceExtension;

	public JiraSoapServiceExtensionImpl(TokenManager tokenManager, SearchServiceExtension searchServiceExtension){

		this.tokenManager = tokenManager;
		this.searchServiceExtension = searchServiceExtension;

	}


	public String[] getIssueKeysWithProject(String token, String[] projectKeys) throws RemoteException {

		User user = tokenManager.retrieveUserNoPermissionCheck(token);
		return searchServiceExtension.getIssueKeysWithProject(user, projectKeys);
		
	}

	public String[] getUpdatedIssueKeysWithProject(String token, String[] projectKeys,
			Date changedSince) throws RemoteException {

		User user = tokenManager.retrieveUserNoPermissionCheck(token);
		return searchServiceExtension.getUpdatedIssueKeysWithProject(user, projectKeys, changedSince);

	}


	public String login(String username, String password)
			throws RemoteException, RemoteAuthenticationException {
		// TODO Auto-generated method stub
		return tokenManager.login(username, password);
	}


	public boolean logout(String token) {
		// TODO Auto-generated method stub
		return tokenManager.logout(token);
	}



}
