package no.miles.mpl.plugins.hudson.appclient;

import hudson.MarkupText;
import hudson.MarkupText.SubText;
import hudson.model.AbstractBuild;
import hudson.scm.ChangeLogAnnotator;
import hudson.scm.ChangeLogSet.Entry;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;
import java.util.regex.Pattern;

import com.sun.syndication.feed.atom.Link;
import com.sun.syndication.propono.atom.client.AtomClientFactory;
import com.sun.syndication.propono.atom.client.ClientCollection;
import com.sun.syndication.propono.atom.client.ClientEntry;
import com.sun.syndication.propono.utils.ProponoException;

public class MplAnnotator extends ChangeLogAnnotator {
	@Override
	public void annotate(AbstractBuild<?,?> build, Entry change, MarkupText text) {
		MplProjectIssueFeedProperty mprp = build.getProject().getProperty(MplProjectIssueFeedProperty.class);
		if(mprp==null || mprp.issueFeed == null)
			return; // not configured

		String url = mprp.issueFeed;

		ClientCollection atomFeed = null;
		try {
			atomFeed = AtomClientFactory.getCollection(url, "test", "test");
		} catch (ProponoException e1) {
			e1.printStackTrace();
			// TODO Auto-generated catch block
			return;

		}

		File file = new File("/home/erlingwl/mpl/log.txt");
		BufferedWriter out = null;
		try {
			out = new BufferedWriter(new FileWriter(file, true));
		} catch (IOException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace();
		}

		for(SubText token : text.findTokens(ISSUE_PATTERN)) {

			String projectKey = token.group(1);
			String issueKey = token.group(2);

			String PROJECTS_PATTERN = "projects/" + projectKey + "/issues";
			boolean sameProject = url.contains(PROJECTS_PATTERN);

			if(sameProject  && atomFeed != null)
			{				

				try {

					ClientEntry entry = atomFeed.getEntry(url + issueKey);	
					List<Link> links = entry.getAlternateLinks();
					for (Link link : links) {
						if(link.getRel().equalsIgnoreCase("alternate")){
							token.surroundWith("<a href='"+ link.getHref() +"'>","</a>");
							
							try {							


								out.write("Surrounded " + url + issueKey + " : " + link.getHref() + "\n");

							} catch (IOException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}

							
//							System.out.println("Surrounded!!");
							break;
						}
					}

				} catch (ProponoException e) {
					
					String s = e.getMessage() + "\n";
					
					StackTraceElement[] elems = e.getStackTrace();
					for (StackTraceElement stackTraceElement : elems) {
//						s += stackTraceElement.getMethodName() + " " + stackTraceElement.getFileName() + " " + stackTraceElement.getLineNumber() + "\n";
					}
					
					String entryURL = url + issueKey + "\n";				
//					String tt = text.toString() + "\n";
					
					try {
						
						out.write(entryURL);
						out.write(s);
//						out.write(tt);
						
					} catch (IOException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					
					// TODO Auto-generated catch block
//					return;
//					e.printStackTrace();
				}
			}
			
					

		}
		
//		String tt = text.toString();
		try {
			
//			out.write(tt);
			out.close();				
		
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}	
	}

	private static final Pattern ISSUE_PATTERN = Pattern.compile("(\\w+)/(\\d+)");


}
