import hudson.MarkupText;
import hudson.MarkupText.SubText;

import java.util.List;
import java.util.regex.Pattern;

import com.sun.syndication.feed.atom.Link;
import com.sun.syndication.propono.atom.client.AtomClientFactory;
import com.sun.syndication.propono.atom.client.ClientCollection;
import com.sun.syndication.propono.atom.client.ClientEntry;
import com.sun.syndication.propono.utils.ProponoException;

import junit.framework.TestCase;


public class FeedTest {

	private static final Pattern ISSUE_PATTERN = Pattern.compile("(\\w+)/(\\d+)");

	public static void main(String[] args) {

		String url = "http://localhost:8070/no.miles.mpl.semantic.app.endpoint/projects/LC/issues/";

		ClientCollection atomFeed = null;
		try {
			atomFeed = AtomClientFactory.getCollection(url, "test", "test");
		} catch (ProponoException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		

		MarkupText text = new MarkupText("mpl/3 LC/3 mpl/2 LC/4<br>mpl-3<br>#3<br>LC-3<br>#3<br>mpl-2<br>#2<br>LC-4<br>#4");

		for(SubText token : text.findTokens(ISSUE_PATTERN)) {


			String projectKey = token.group(1);
			String issueKey = token.group(2);

			String PROJECTS_PATTERN = "projects/" + projectKey + "/issues";
			boolean sameProject = url.contains(PROJECTS_PATTERN);

			if(sameProject  && atomFeed != null)
			{
				
				System.out.println("Same project!!");

				try {

					ClientEntry entry = atomFeed.getEntry(url + issueKey);

					List<Link> links = entry.getAlternateLinks();
					for (Link link : links) {
						if(link.getRel().equalsIgnoreCase("alternate")){
							token.surroundWith("<a href='"+ link.getHref() +"'>","</a>");
							
							System.out.println("Surrounded..");
							
							break;
						}
					}


				} catch (ProponoException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			}			


		}
		
		System.out.println(text.toString());

	}

}
