package org.eclipse.mylyn.mpl.ui;

import org.eclipse.jface.wizard.Wizard;
import org.eclipse.mylyn.internal.tasks.ui.TasksUiImages;
import org.eclipse.mylyn.tasks.core.AbstractRepositoryConnector;
import org.eclipse.mylyn.tasks.core.AbstractRepositoryQuery;
import org.eclipse.mylyn.tasks.core.TaskRepository;
import org.eclipse.mylyn.tasks.ui.TasksUiPlugin;

public class MplNewQueryWizard extends Wizard{
	
	private static final String TITLE = "New Miles Platform Query";
	private final TaskRepository repository;
	private MplQueryWizardPage queryPage;

	public MplNewQueryWizard (TaskRepository repository){
		this.repository = repository;		
		setWindowTitle(TITLE);
		setNeedsProgressMonitor(true);
		setDefaultPageImageDescriptor(TasksUiImages.BANNER_REPOSITORY);
	}
	
	@Override
	public boolean canFinish() {
		return queryPage.isPageComplete();
	}
	
	@Override
	public boolean performFinish() {
		AbstractRepositoryQuery query = queryPage.getQuery();
		
		System.out.println("Should perform query");		
		if (query != null) {
			TasksUiPlugin.getTaskListManager().getTaskList().addQuery(query);
			AbstractRepositoryConnector connector = TasksUiPlugin.getRepositoryManager().getRepositoryConnector(
					repository.getConnectorKind());
			
			System.out.println(repository.getConnectorKind());
			
			if (connector != null) {
				
				System.out.println("connectorkind " + connector.getConnectorKind());
				TasksUiPlugin.getSynchronizationManager().synchronize(connector, query, null, true);
			}
		}
		return true;
	}
	
	@Override
	public void addPages() {
		queryPage = new MplQueryWizardPage(repository);
		queryPage.setWizard(this);
		addPage(queryPage);
	}

}
