package org.eclipse.mylyn.mpl.ui;

import java.util.ArrayList;
import java.util.Set;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.mylyn.tasks.core.AbstractAttachmentHandler;
import org.eclipse.mylyn.tasks.core.AbstractRepositoryConnector;
import org.eclipse.mylyn.tasks.core.AbstractRepositoryQuery;
import org.eclipse.mylyn.tasks.core.AbstractTask;
import org.eclipse.mylyn.tasks.core.AbstractTaskDataHandler;
import org.eclipse.mylyn.tasks.core.ITaskCollector;
import org.eclipse.mylyn.tasks.core.RepositoryTaskData;
import org.eclipse.mylyn.tasks.core.TaskRepository;
import org.eclipse.mylyn.tasks.core.TaskRepositoryLocationFactory;

public class MplRepositoryConnector extends AbstractRepositoryConnector{
	
	private final MplTaskDataHandler taskDataHandler = new MplTaskDataHandler(this);

	private TaskRepositoryLocationFactory taskRepositoryLocationFactory = new TaskRepositoryLocationFactory();

	private MplTaskRepositoryListener clientManager;
	
	@Override
	public boolean canCreateNewTask(TaskRepository repository) {
		// TODO Auto-generated method stub
		return true;
	}

	@Override
	public boolean canCreateTaskFromKey(TaskRepository repository) {
		// TODO Auto-generated method stub
		return false;
	}
	
	public TaskRepositoryLocationFactory getTaskRepositoryLocationFactory() {
		return taskRepositoryLocationFactory;
	}

	public synchronized void setTaskRepositoryLocationFactory(
			TaskRepositoryLocationFactory taskRepositoryLocationFactory) {
		this.taskRepositoryLocationFactory = taskRepositoryLocationFactory;
		if (this.clientManager != null) {
			clientManager.setTaskRepositoryLocationFactory(taskRepositoryLocationFactory);
		}
	}

	@Override
	public AbstractTask createTask(String repositoryUrl, String id,
			String summary) {
		// TODO Auto-generated method stub
		return new MplTask(repositoryUrl, id, summary);
	}

	@Override
	public AbstractAttachmentHandler getAttachmentHandler() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getConnectorKind() {
		// TODO Auto-generated method stub
		return MplCorePlugin.REPOSITORY_KIND;
	}

	@Override
	public String getLabel() {
		// TODO Auto-generated method stub
		return "Miles Platform";
	}

	@Override
	public String getRepositoryUrlFromTaskUrl(String taskFullUrl) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public AbstractTaskDataHandler getTaskDataHandler() {
		// TODO Auto-generated method stub
		return taskDataHandler;
	}

	@Override
	public String getTaskIdFromTaskUrl(String taskFullUrl) {
		// TODO Auto-generated method stub
		return "taskIdFromTaskUrl";
	}

	@Override
	public String getTaskUrl(String repositoryUrl, String taskId) {
		// TODO Auto-generated method stub
		return "taskUrl";
	}

	@Override
	public boolean markStaleTasks(TaskRepository repository,
			Set<AbstractTask> tasks, IProgressMonitor monitor)
			throws CoreException {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public IStatus performQuery(AbstractRepositoryQuery query,
			TaskRepository repository, IProgressMonitor monitor,
			ITaskCollector resultCollector) {
		
		if(query instanceof MplRepositoryQuery)
		{
		
		System.out.println("Performing query here...??");
		
		// TODO Auto-generated method stub
		monitor.beginTask("Running query", IProgressMonitor.UNKNOWN);
		
//		AbstractTask task = createTask(repository.getUrl(), "taskid", "summary");
		
		System.out.println("test..");
		
		System.out.println("repository username " + repository.getUserName());
		System.out.println("repository password " + repository.getPassword());
		System.out.println("repository url " + repository.getUrl());
		
		ArrayList<MplTask> tasks;
		try {
			tasks = MplAtomLib.fetchTasks(repository.getUserName(), repository.getPassword(), repository.getUrl());
		
			System.out.println("Have fetched tasks?");
			
			for (MplTask mplTask : tasks) {
				System.out.println("trying to accept : mplTask " + mplTask.getTaskId());
				resultCollector.accept(mplTask);
			}	
		
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
//		ArrayList<MplTask> tasks = MplRestLib.fetchTasks(repository.getUrl());
		
	
		
		monitor.done();
		}
		
		return Status.OK_STATUS;
	}

	@Override
	public void updateAttributes(TaskRepository repository,
			IProgressMonitor monitor) throws CoreException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void updateTaskFromRepository(TaskRepository repository,
			AbstractTask repositoryTask, IProgressMonitor monitor)
			throws CoreException {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void updateTaskFromTaskData(TaskRepository repository,
			AbstractTask repositoryTask, RepositoryTaskData taskData) {
		// TODO Auto-generated method stub
		
	}

	public MplTaskRepositoryListener getClientManager() {
		if (clientManager == null) {
			clientManager = new MplTaskRepositoryListener();
		}
		return clientManager;
	}



}
