package org.eclipse.mylyn.mpl.ui;

import org.eclipse.mylyn.tasks.core.RepositoryTemplate;
import org.eclipse.mylyn.tasks.core.TaskRepository;
import org.eclipse.mylyn.tasks.ui.AbstractRepositoryConnectorUi;
import org.eclipse.mylyn.tasks.ui.wizards.AbstractRepositorySettingsPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class MplRepositorySettingsPage extends AbstractRepositorySettingsPage{
	
	private Button compressionButton;

	private boolean characterEncodingValidated;
	
	private Button autoRefreshConfigurationButton;

	public MplRepositorySettingsPage(String title, String description,
			AbstractRepositoryConnectorUi repositoryUi) {
		super(title, description, repositoryUi);
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void createAdditionalControls(Composite parent) {
		// TODO Auto-generated method stub		
		for (RepositoryTemplate template : connector.getTemplates()) {
			serverUrlCombo.add(template.label);
		}

		if (repository != null) {
			this.characterEncodingValidated = true;
		}

		serverUrlCombo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				String text = serverUrlCombo.getText();
				RepositoryTemplate template = connector.getTemplate(text);
				if (template != null) {
					repositoryLabelEditor.setStringValue(template.label);
					setUrl(nvl(template.repositoryUrl));
					getContainer().updateButtons();
				}
			}

			private String nvl(String s) {
				return s == null ? "" : s;
			}
		});

		Label compressionLabel = new Label(parent, SWT.NONE);
		compressionLabel.setText("Compression:");
		compressionButton = new Button(parent, SWT.CHECK | SWT.LEFT);
		if (repository != null) {
			compressionButton.setSelection(true);
		}

		Label label = new Label(parent, SWT.NONE);
		label.setText("Automatically refresh attributes:");
		autoRefreshConfigurationButton = new Button(parent, SWT.CHECK | SWT.LEFT);
		autoRefreshConfigurationButton.setToolTipText("If checked Mylyn will periodically update the the repository attributes. Note: This can cause a significant load on the repository if it has many projects.");
		if (repository != null) {
			autoRefreshConfigurationButton.setSelection(true);
		}
	}
	
	@Override
	public boolean isPageComplete() {

		return true;
	}

	@Override
	public void updateProperties(TaskRepository repository) {
		repository.setProperty("refreshConfiguration", "true");	}

	@Override
	protected Validator getValidator(TaskRepository repository) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected boolean isValidUrl(String name) {
		// TODO Auto-generated method stub		
		
		
		return MplAtomLib.validateUrl(getUserName(), getPassword(), name);
	}

}
