package org.eclipse.mylyn.mpl.ui;

import java.util.HashSet;
import java.util.Set;

import org.eclipse.mylyn.tasks.core.AbstractRepositoryQuery;
import org.eclipse.mylyn.tasks.core.AbstractTask;
import org.eclipse.mylyn.tasks.core.AbstractTaskListFactory;
import org.w3c.dom.Element;

public class MplTaskListFactory extends AbstractTaskListFactory{

	private static final String KEY_MPL = "mpl";

	private static final String KEY_MPL_TASK = KEY_MPL + AbstractTaskListFactory.KEY_TASK;
	
	private static final String KEY_MPL_QUERY = KEY_MPL + AbstractTaskListFactory.KEY_QUERY;
	
	private static final String KEY_SUPPORTS_SUBTASKS = "SupportsSubtasks";
	
	@Override
	public boolean canCreate(AbstractTask task) {
		// TODO Auto-generated method stub
		return task instanceof MplTask;
	}	
	
	@Override
	public boolean canCreate(AbstractRepositoryQuery query){
		return query instanceof MplRepositoryQuery;
	}

	@Override
	public AbstractTask createTask(String repositoryUrl, String taskId,
			String label, Element element) {
		// TODO Auto-generated method stub
		return new MplTask(repositoryUrl, taskId, label);
	}

	@Override
	public String getTaskElementName() {
		// TODO Auto-generated method stub
		return KEY_MPL_TASK;
	}
	
	@Override
	public Set<String> getQueryElementNames() {
		Set<String> names = new HashSet<String>();
		names.add(KEY_MPL_QUERY);
		return names;
	}
	
	@Override
	public String getQueryElementName(AbstractRepositoryQuery query) {
		return query instanceof MplRepositoryQuery ? KEY_MPL_QUERY : "";
	}
	
	@Override
	public AbstractRepositoryQuery createQuery(String repositoryUrl, String queryString, String label, Element element) {
		return new MplRepositoryQuery(repositoryUrl, label);
	}
}
