package org.eclipse.mylyn.mpl.ui;

import org.eclipse.mylyn.tasks.ui.TaskRepositoryLocationUiFactory;
import org.eclipse.mylyn.tasks.ui.TasksUiPlugin;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;


public class MplUiPlugin extends AbstractUIPlugin{
	
	public static final String PLUGIN_ID = "org.eclipse.mylyn.mpl.ui";

	private static MplUiPlugin INSTANCE;

	public final static String REPOSITORY_KIND = "mpl";

	public final static String JIRA_CLIENT_LABEL = "Miles Platform";

	public final static String TITLE_MESSAGE_DIALOG = "Mylyn Miles Platform Client";

	public MplUiPlugin(){
		INSTANCE = this;
	}
	
	@Override
	public void start(BundleContext context) throws Exception {
		super.start(context);
		
		MplCorePlugin.getDefault().getConnector().setTaskRepositoryLocationFactory(new TaskRepositoryLocationUiFactory());
		TasksUiPlugin.getRepositoryManager().addListener(MplCorePlugin.getDefault().getConnector().getClientManager());
		
//		MplRepositoryConnector mplConnector = (MplRepositoryConnector) TasksUiPlugin.getRepositoryManager().getRepositoryConnector(MplCorePlugin.REPOSITORY_KIND);

//		JiraClientFactory.getDefault().setTaskRepositoryLocationFactory(new TaskRepositoryLocationUiFactory(), false);
		
//		TasksUiPlugin.getRepositoryManager().addListener(mplConnector.getClientManager());

		
//		MplPlugin.getDefault().getConnector().setTaskRepositoryLocationFactory(new TaskRepositoryLocationUiFactory());
//		TasksUiPlugin.getRepositoryManager().addListener(TracCorePlugin.getDefault().getConnector().getClientManager());

		
//		MplTaskRepositoryListener mplTrL = new MplTaskRepositoryListener();
		
//		TasksUiPlugin.getRepositoryManager().addListener(listener);
		
//		JiraClientFactory.getDefault().setTaskRepositoryLocationFactory(new TaskRepositoryLocationUiFactory(), false);
	}

	@Override
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
		INSTANCE = null;
//		JiraClientFactory.getDefault().logOutFromAll();
	}

	public static MplUiPlugin getDefault() {
		return INSTANCE;
	}
	
}
