package org.eclipse.mylyn.mpl.ui.editor;

import org.eclipse.mylyn.mpl.ui.MplTask;
import org.eclipse.mylyn.mpl.ui.MplUiPlugin;
import org.eclipse.mylyn.tasks.core.AbstractTask;
import org.eclipse.mylyn.tasks.core.TaskRepository;
import org.eclipse.mylyn.tasks.ui.TasksUiPlugin;
import org.eclipse.mylyn.tasks.ui.editors.AbstractTaskEditorFactory;
import org.eclipse.mylyn.tasks.ui.editors.RepositoryTaskEditorInput;
import org.eclipse.mylyn.tasks.ui.editors.TaskEditor;
import org.eclipse.mylyn.tasks.ui.editors.TaskEditorInput;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorPart;

public class MplTaskEditorFactory extends AbstractTaskEditorFactory{

	@Override
	public boolean canCreateEditorFor(AbstractTask task) {
		
		
		
		// TODO Auto-generated method stub
		boolean b = task instanceof MplTask;
		
		System.out.println("canCreateEditor for task " + b);
		
		return b;
	}

	@Override
	public boolean canCreateEditorFor(IEditorInput input) {
		
		
		
		boolean b = false;
		
		if (input instanceof RepositoryTaskEditorInput) {
			RepositoryTaskEditorInput existingInput = (RepositoryTaskEditorInput) input;
			b = existingInput.getTaskData() != null
					&& MplUiPlugin.REPOSITORY_KIND.equals(existingInput.getRepository().getConnectorKind());
		}
		
		System.out.println("canCreateEditor for input" + b);
		
		return b;
	}

	@Override
	public IEditorPart createEditor(TaskEditor parentEditor,
			IEditorInput editorInput) {
		
		System.out.println("Create editor");
		
		if (editorInput instanceof RepositoryTaskEditorInput) {
			RepositoryTaskEditorInput taskInput = (RepositoryTaskEditorInput) editorInput;
			if (taskInput.getTaskData().isNew()) {
				
				System.out.println("new..");
				
				return new NewMplTaskEditor(parentEditor);
			} else {
				
				System.out.println("existing..");
				
				return new MplTaskEditor(parentEditor);
			}
		} else if (editorInput instanceof TaskEditorInput) {
			
			System.out.println("existing..");
			
			return new MplTaskEditor(parentEditor);
		}
		
		System.out.println("null..");
		
		return null;
	}

	@Override
	public IEditorInput createEditorInput(AbstractTask task) {
		
		System.out.println("createEditorInput");
		
		// TODO Auto-generated method stub
		MplTask mplTask = (MplTask) task;
		TaskRepository repository = TasksUiPlugin.getRepositoryManager().getRepository(MplUiPlugin.REPOSITORY_KIND,
				mplTask.getRepositoryUrl());
		try {
			
			System.out.println("new input..");
			
			return new RepositoryTaskEditorInput(repository, mplTask.getTaskId(), mplTask.getUrl());
		} catch (Exception e) {
//			StatusHandler.fail(e, "Could not create JIRA editor input", true);
		}
		
		System.out.println("null..");
		
		return null;
	}

	@Override
	public String getTitle() {
		
		System.out.println("getTitle");
		
		// TODO Auto-generated method stub
		return "Miles Platform";
	}
	
	@Override
	public boolean providesOutline() {
		return true;
	}


}
