package no.miles.mpl.layers.app;

import java.util.Date;

import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;

import no.miles.mpl.atomextension.issue.IssueModule;
import no.miles.mpl.atomextension.issue.IssueModuleImpl;
import no.miles.mpl.wrapper.Issue;

public class IssueEntry extends Entry {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2401154565972446112L;

	public IssueEntry(IssueFeed issueFeed, Issue issue) {

		super();

		this.setId(issueFeed.getId() + issue.getKey());			
		this.setTitle(issue.getKey());			
		this.setUpdated(new Date());
		
//		this.setForeignMarkup(foreignMarkup)

		Content summary = new Content();
		summary.setValue(issue.getSummary());
		summary.setType("text");
		this.setSummary(summary);

		IssueModule issueModule = new IssueModuleImpl();

		issueModule.setAssignedTo(issue.getAssigned_to());
		issueModule.setComponents(issue.getComponents());
		issueModule.setCreated(issue.getCreated());
		issueModule.setDescription(issue.getDescription());
		issueModule.setPriority(issue.getPriority());
		issueModule.setReportedBy(issue.getReported_by());
		issueModule.setResolution(issue.getResolution());
		issueModule.setStatus(issue.getStatus());
		issueModule.setType(issue.getType());
		issueModule.setVersions(issue.getVersions());	

		this.getModules().add(issueModule);		
	}

}
