package no.miles.mpl.layers.app;

import java.util.ArrayList;
import java.util.Date;

import no.miles.mpl.atomextension.issue.IssueModuleImpl;
import no.miles.mpl.wrapper.Issue;
import no.miles.mpl.wrapper.Project;

import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Feed;

public class IssueFeed extends Feed {
	
	public IssueFeed(String projectName, String baseUrl){
		super();
		
		this.setId(baseUrl + "projects/" + projectName + "/issues/");
		this.setTitle(projectName + " issues");
		this.setUpdated(new Date());
		
		this.getModules().add(new IssueModuleImpl());
	
		Project project = Projects.getProject(projectName);
	
		this.setEntries(getIssueEntries(project));
	}
	
	private ArrayList<Entry> getIssueEntries(Project project){
		
		ArrayList<Entry> entries = new ArrayList<Entry>();
		
		ArrayList<Issue> issues = project.getIssues();
		for (Issue issue : issues) {
			
			Entry entry = new IssueEntry(this, issue);
			
			entries.add(entry);
		}
		
		return entries;
	}
	
	
}
