package no.miles.mpl.layers.app;


import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;

import com.sun.syndication.feed.WireFeed;
import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Feed;
import com.sun.syndication.feed.atom.Person;
import com.sun.syndication.propono.atom.common.AtomService;
import com.sun.syndication.propono.atom.common.Categories;
import com.sun.syndication.propono.atom.common.Collection;
import com.sun.syndication.propono.atom.common.Workspace;
import com.sun.syndication.propono.atom.server.AtomException;
import com.sun.syndication.propono.atom.server.AtomHandler;
import com.sun.syndication.propono.atom.server.AtomMediaResource;
import com.sun.syndication.propono.atom.server.AtomRequest;

public class MplAtomHandler implements AtomHandler{

	private HttpServletRequest httpReq;

	private static String PROJECTS = "projects";
	private static String ISSUES = "issues";
	private static String BASE = "http://localhost:8070/no.miles.mpl.layers.app/";	

	public MplAtomHandler(HttpServletRequest req){
		this.httpReq = req;
	}	

	@Override
	public void deleteEntry(AtomRequest req) throws AtomException {
		// TODO Auto-generated method stub

	}


	@Override
	public AtomService getAtomService(AtomRequest req) throws AtomException {

		System.out.println("Uri: " + req.getRequestURL());
		System.out.println("getService..");

		Workspace workspace = new Workspace("WS","collections");		
		Collection entryCol = new Collection("mpl" + ISSUES,"text", req.getRequestURL().toString() + PROJECTS + "/" + "mpl" +"/" + ISSUES + "/");
		entryCol.setAccept("entry");		

		System.out.println("accepts: " + entryCol.getAccept());

		workspace.addCollection(entryCol);

		AtomService service = new AtomService();
		service.addWorkspace(workspace);	

		return service;
	}

	@Override
	public String getAuthenticatedUsername() {
		// TODO Auto-generated method stub
		System.out.println("getAuthUserName");

		return "test";
	}

	@Override
	public Categories getCategories(AtomRequest req) throws AtomException {
		// TODO Auto-generated method stub
		System.out.println("getCat");

		return null;
	}

	@Override
	public Feed getCollection(AtomRequest req) throws AtomException {

		String[] pathInfo = StringUtils.split(req.getPathInfo(),"/");		

		System.out.println("getCollection " + req.toString());
		System.out.println("pathInfo: " +  pathInfo.toString());

		//We're dealing with a project
		if(pathInfo[0].equals("projects")){	

			if(pathInfo.length == 1)
			{
				Feed feed = new ProjectFeed(BASE);
				return feed;
			}
			else if (pathInfo.length == 3 && pathInfo[2].equals("issues"))
			{

				String projectName = pathInfo[1];			
				System.out.println("Project: " + projectName);	

				//The project exists!
				if(Projects.projectExists(projectName)){				
					Feed feed = new IssueFeed(projectName, BASE);
					return feed;				
				}	
			}
		}

		return null;		

	}

	@Override
	public Entry getEntry(AtomRequest req) throws AtomException {
		// TODO Auto-generated method stub
		System.out.println("getEntry");
		System.out.println("entry url " + req.getRequestURL());

		//Test entry..
		Entry entry = new Entry();
		entry.setId(req.getRequestURL().toString());
		entry.setCreated(new Date());
		entry.setTitle("jadda");

		Content summary = new Content();
		summary.setValue("this is my summary");		
		entry.setSummary(summary);		

//		List<Entry> entries = new ArrayList<Entry>();
//		entries.add(entry);	

		return entry;
	}

	@Override
	public AtomMediaResource getMediaResource(AtomRequest req)
	throws AtomException {
		// TODO Auto-generated method stub
		System.out.println("getMediaResource");

		return null;
	}

	@Override
	public boolean isAtomServiceURI(AtomRequest req) {
		// TODO Auto-generated method stub
		System.out.println("isAtomS");

		System.out.println("requrl " + req.getPathInfo());

		String[] pathInfo = StringUtils.split(req.getPathInfo(),"/");

		if (pathInfo.length == 0) return true;

		return false;
	}

	@Override
	public boolean isCategoriesURI(AtomRequest req) {
		// TODO Auto-generated method stub
		System.out.println("isCat");

		return false;
	}

	@Override
	public boolean isCollectionURI(AtomRequest req) {
		// TODO Auto-generated method stub
		String[] pathInfo = StringUtils.split(req.getPathInfo(),"/");

		System.out.println("isColl");
		System.out.println(pathInfo.length);

		//We're dealing with a project
		if(pathInfo.length == 3 && pathInfo[0].equals("projects") && pathInfo[2].equals("issues")){		
			String projectName = pathInfo[1];			
			System.out.println("Project: " + projectName);	

			//The project exists!
			if(Projects.projectExists(projectName)){				
				return true;
			}			
		}

		else if(pathInfo.length == 1 && pathInfo[0].equals("projects"))
		{
			return true;
		}

//		if (pathInfo.length == 3 && pathInfo[2].equals("issues")) return true;

		return false;
	}

	@Override
	public boolean isEntryURI(AtomRequest req) {
		// TODO Auto-generated method stub
		System.out.println("isEntryURI");

		String[] pathInfo = StringUtils.split(req.getPathInfo(),"/");

		System.out.println("isColl");
		System.out.println(pathInfo.length);

		if (pathInfo.length > 3 && pathInfo[2].equals("issues")) return true;


		return false;
	}

	@Override
	public boolean isMediaEditURI(AtomRequest req) {
		// TODO Auto-generated method stub
		System.out.println("isMediaEditURI");

		return false;
	}

	@Override
	public String postEntry(AtomRequest req, Entry entry) throws AtomException {
		// TODO Auto-generated method stub


		return null;
	}

	@Override
	public String postMedia(AtomRequest req, Entry entry) throws AtomException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void putEntry(AtomRequest req, Entry entry) throws AtomException {
		// TODO Auto-generated method stub

	}

	@Override
	public void putMedia(AtomRequest req) throws AtomException {
		// TODO Auto-generated method stub

	}

}
