package no.miles.mpl.layers.app;

import java.util.ArrayList;
import java.util.Date;

import no.miles.mpl.atomextension.projects.*;
import no.miles.mpl.wrapper.Project;

import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Link;

public class ProjectEntry extends Entry{

	public ProjectEntry(ProjectFeed projectFeed, Project project){
		super();
		
		this.setId(projectFeed.getId() + project.getKey() + "/issues/");
		this.setTitle(project.getName());
		this.setUpdated(new Date());				

		ArrayList<Link> links = new ArrayList<Link>();
		Link link = new Link();
		link.setHref(this.getId());;
		links.add(link);
		this.setAlternateLinks(links);	

		Content summary = new Content();
		summary.setType("text");
		summary.setValue("Miles Platform project with bugtracker " + project.getBugtrackerName() + " and bugtracker url " + project.getBugtrackerUrl());
		this.setSummary(summary);

		ProjectsModule projectsModule = new ProjectsModuleImpl();			
		projectsModule.setBugtrackerName(project.getBugtrackerName());
		projectsModule.setBugtrackerUrl(project.getBugtrackerUrl());					
		
		this.getModules().add(projectsModule);
		
	}
	
}
