package no.miles.mpl.restful;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;


import javax.xml.XMLConstants;
import javax.xml.namespace.NamespaceContext;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class Common {

	public static String PROJECTS = "/projects/";
	public static String LOCALHOST = "http://localhost:8182";
	public static String CONFIG = "/config/";
	public static String XSD_URI = "http://localhost:8182/xsd/";
	public static String CONFIG_PATH = "target/classes/config/config.xml";
	public static String ROOT_PATH = "target/classes/config/";
	public static String MPL_NS = "http://platform.miles.no/";
	public static String MPL_PREFIX = "mpl";

	public Common(){

	}

	public static Document getDocument(String path){

		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		dbf.setNamespaceAware(true);
//		dbf.setValidating(false);		
		DocumentBuilder db;

		try {
			db = dbf.newDocumentBuilder();
			Document doc = db.parse(path);	
			return doc;

		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
		} catch (SAXException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
		}	

		return null;
	}


	public static boolean storeDocument(Document doc, String path){
		Transformer transformer;
		try {
			transformer = TransformerFactory.newInstance().newTransformer();
			transformer.setOutputProperty(OutputKeys.INDENT, "yes");

			//initialize StreamResult with File object to save to file
			StreamResult result = new StreamResult(new File(path).toURI().getPath());
			DOMSource source = new DOMSource(doc);
			transformer.transform(source, result);

		} catch (TransformerConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		} catch (TransformerFactoryConfigurationError e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		} catch (TransformerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}

		return true;

	}

	public static boolean validateDocument(Document doc, String xsdUrl)
	{
//		SchemaFactory factory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);			    
//		Schema schema;
//		try {
//			schema = factory.newSchema(new URL(xsdUrl));
//			Validator validator = schema.newValidator();			    
//			validator.validate(new DOMSource(doc));
//			return true;
//
//		} catch (MalformedURLException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (SAXException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}			    

//		return false;		
		
		return true;
	}

	public static String getNodeValue(Document doc, String expression, String prefix, String namespace){
		
		XPathFactory factory = XPathFactory.newInstance();
		XPath xpath = factory.newXPath();
		
		NamespaceContext namespaceContext= new MplNamespace(prefix, namespace);		
		xpath.setNamespaceContext(namespaceContext);	

		try {

			XPathExpression expr = xpath.compile(expression);
			String result = expr.evaluate(doc);

			System.out.println("Result " + result);
//			NodeList nodeList = (NodeList) result;
			
			return result;



		} catch (XPathExpressionException e) {
			// TODO Auto-generated catch block
			System.out.println("Feil her!");
			e.printStackTrace();
		}

		return null;
	}

}
