package no.miles.mpl.restful;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import no.miles.mpl.wrapper.datastructures.*;
import no.miles.mpl.wrapper.exception.BadRequestException;
import no.miles.mpl.wrapper.exception.InternalServerErrorException;

import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.data.Status;
import org.restlet.resource.DomRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.StringRepresentation;
import org.restlet.resource.Variant;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class RestIssue extends RestIssues{

	protected String issueKey;

	public RestIssue(Context context, Request request, Response response) {
		super(context, request, response);
		this.issueKey = (String) request.getAttributes().get("issue");	

		getVariants().add(new Variant(MediaType.TEXT_XML));
	}

	@Override
	public Representation getRepresentation(Variant variant) {
		Representation result = null;

		System.out.println(variant.getMediaType().toString());

		if(variant.getMediaType().equals(MediaType.TEXT_XML)){

			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();

			System.out.println(bugTracker);
			
			try {

				if(bugTracker != null)
				{
					System.out.println(projectKey + " " + issueKey);
					
					Issue issue = bugTracker.getIssue(username, password, projectKey, issueKey);							
					if(issue != null)
					{
						DocumentBuilder db = dbf.newDocumentBuilder();
						Document doc = db.newDocument();
						Node issueNode = doc.createElement("issue");

						Node urlNode = doc.createElement("url");
						urlNode.setTextContent(uri);

						issueNode.appendChild(urlNode);

						Node summary = doc.createElement("summary");
						summary.setTextContent(issue.getSummary());

						issueNode.appendChild(summary);				

						doc.appendChild(issueNode);			

						DomRepresentation domRep = new DomRepresentation(MediaType.TEXT_XML, doc);
						result = domRep;	
					}
					else {

						getResponse().setStatus(Status.CLIENT_ERROR_NOT_FOUND);
					}

				}
			} catch (ParserConfigurationException e1) {
				e1.printStackTrace();
			} catch (BadRequestException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InternalServerErrorException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		else {
			result = new StringRepresentation("Du ba om " + variant.getMediaType().toString());
		}

		return result;
	}

}
