package no.miles.mpl.restful;

import java.io.IOException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.resource.DomRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.Resource;
import org.restlet.resource.Variant;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

public class Xsd extends Resource{
	
	private static String XSD_PATH = "target/classes/xsd/config.xsd";

	public Xsd(Context context, Request request, Response response) {
		super(context, request, response);
		getVariants().add(new Variant(MediaType.TEXT_XML));
	}		
	
	@Override
	public Representation getRepresentation(Variant variant) {
		Representation result = null;

		if(variant.getMediaType().equals(MediaType.TEXT_XML)){

			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;
			
			try {
				db = dbf.newDocumentBuilder();
				Document doc = db.parse(XSD_PATH);				
				DomRepresentation domRep = new DomRepresentation(MediaType.TEXT_XML, doc);
				result = domRep;
				
			} catch (ParserConfigurationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (SAXException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}				
		}
		return result;
	}
}
