package no.miles.mpl.semant.app.endpoint.datahandlers;

import java.util.Date;
import java.util.HashMap;

import net.sf.ehcache.CacheManager;

/**
 * This class are used to hold the CacheManagers..
 * @author erlingwl
 *
 */
public class CacheManagerFactory {

	private static CacheManager instance = null;
	
	private static CacheManager entryCacheManager = null;
	
	private static HashMap<String, Date> lastRefresh = null;

	protected CacheManagerFactory() {
		// TODO Auto-generated constructor stub
	}

	public static CacheManager getCacheManager() {		
		
		if(instance == null) {
			
			instance = CacheManager.create();
			
		}
		return instance;
	}
	
	public static CacheManager getEntryCacheManager() {		
		
		if(entryCacheManager == null) {
			
			entryCacheManager = CacheManager.create();
			
		}
		return entryCacheManager;
	}
	
	
	public static Date getLastRefreshedDate(String cacheName) {
		
		Date date = getLastRefreshed().get(cacheName);
		return date;
		
		
	} 
	
	public static synchronized void setLastRefreshedDate(String cacheName, Date date) {
		
		getLastRefreshed().put(cacheName, date);
		
	}
	
	private static HashMap<String, Date> getLastRefreshed() {		
		
		if(lastRefresh == null) {
			
			lastRefresh = new HashMap<String, Date>();
			
		}
		return lastRefresh;
	}
	
	
}
