package no.miles.mpl.semant.app.endpoint.datahandlers;

import java.util.Date;

import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Person;
import com.sun.syndication.propono.atom.server.AtomException;

import no.miles.mpl.wrapper.BugTrackerWrapperInterface;
import no.miles.mpl.wrapper.datastructures.Comment;
import no.miles.mpl.wrapper.datastructures.Issue;
import no.miles.mpl.wrapper.datastructures.Project;
import no.miles.mpl.wrapper.exception.BadRequestException;
import no.miles.mpl.wrapper.exception.InternalServerErrorException;

public class Comments {

	/**
	 * Fetch comments..
	 * @param username
	 * @param password
	 * @param projectKey
	 * @param issueKey
	 * @return
	 * @throws BadRequestException
	 * @throws InternalServerErrorException
	 */
	public static Comment[] getComments(String username, String password, String projectKey, String issueKey) throws BadRequestException, InternalServerErrorException{

		BugTrackerWrapperInterface bugTracker = Projects.getBugTracker(null, projectKey, username, password);

		System.out.println("Fetching issues..."  + new Date().toString());

		return bugTracker.getComments(username, password, projectKey, issueKey);	

	}

	public static String addComment(String username, String password, String projectKey, String issueKey, Entry entry) throws InternalServerErrorException, BadRequestException{

		BugTrackerWrapperInterface bugTracker = Projects.getBugTracker(null, projectKey, username, password);

		if(entry.getContents() != null && entry.getContents().size() > 0)
		{
			Content content = (Content) entry.getContents().get(0);

			if(content != null && content.getValue() != null && content.getType().equalsIgnoreCase("text/rdf+n3")){

				try {
					Comment comment = Comment.parseN3(content.getValue());

					bugTracker.addComment(username, password, projectKey, issueKey, comment);

					return "new id";

				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
					throw new InternalServerErrorException(e.getMessage());
				}

			}


		}

		//If here try to parse pure Atom instead..

		String author = username;

		if(entry.getAuthors() != null || entry.getAuthors().size() > 0){
			Person person = (Person) entry.getAuthors().get(0);
			if(person.getName() != null){
				author = person.getName();
			}
		}

		if(entry.getSummary() != null && entry.getSummary().getValue() != null){

			Date created = new Date();
			if(entry.getCreated() != null)
				created = entry.getCreated();

			Comment comment = new Comment(author, entry.getSummary().getValue(), created);

			bugTracker.addComment(username, password, projectKey, issueKey, comment);

			return "new id";
		} else {
			throw new BadRequestException("Couldn't get content from entry");
		}


	}

}
