package no.miles.mpl.semant.app.endpoint.datahandlers;

import java.util.Date;
import java.util.HashMap;

/**
 * This class are used to provide editUris to entries..
 * @author erlingwl
 *
 */
public class ConcurrencyManager {
	
	public static final String VERSION_PREFIX = "v";
	
	private static HashMap<String, Integer> editUris;

	
	/**
	 * Returns the edit uri
	 * @param entryId
	 * @return
	 */
	public static String getEditUri(String entryId) {
		
		if(!entryId.endsWith("/"))
			entryId += "/";		
		
		Integer version = getEditUris().get(entryId);
		
		if(version == null || version <= 0){
			
			incrementEditUri(entryId);
			
			version = getEditUris().get(entryId);			
		}		
	
		
		if(entryId.endsWith("/"))
			entryId = entryId.substring(0, entryId.length() - 2);
		
		return entryId + VERSION_PREFIX + version.toString() + "/";		
		
	} 
	
	/**
	 * Increment (or initialize the edit-uri)
	 * @param entryId
	 */
	public static synchronized void incrementEditUri(String entryId) {
		
		if(!entryId.endsWith("/"))
			entryId += "/";
		
		
		Integer previousVersion = getEditUris().get(entryId);
		
		Integer newVersion = 1;
		
		if(previousVersion != null && previousVersion >= 1){			
			newVersion = previousVersion++;	
			
			
		}
		
		getEditUris().put(entryId, newVersion);
		
		
	}
	
	private static HashMap<String, Integer> getEditUris() {		
		
		if(editUris == null) {
			
			editUris = new HashMap<String, Integer>();
			
		}
		return editUris;
	}
	
	
}
