package no.miles.mpl.semant.app.endpoint.datahandlers;

import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.sql.DataSource;

import no.miles.mpl.wrapper.exception.InternalServerErrorException;

import com.hp.hpl.jena.db.DBConnection;
import com.hp.hpl.jena.db.IDBConnection;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.ModelMaker;
import com.hp.hpl.jena.util.FileManager;

public class JenaHandler {

	
	public static String BAETLEN3 = "Baetle.n3";
	
	
	public static ModelMaker getModelMaker() throws InternalServerErrorException{

		// create a model maker with the given connection parameters
		ModelMaker maker = ModelFactory.createModelRDBMaker(getConnection());

		return maker;

	}



//	private static Connection getConnection()
	private static IDBConnection getConnection() throws InternalServerErrorException
	{
//		Connection conn;
		IDBConnection conn;
//		try {

//		Properties props = new Properties();		
//		props.load(new FileInputStream("/target/no.miles.mpl.layers.app-1.0-SNAPSHOT/WEB-INF/classes/db.properties"));			
//		String url = props.getProperty("url");
//		String user = props.getProperty("user");
//		String password = props.getProperty("password");

//		String url = "jdbc:postgresql:mpldb";
//		String user = "mpl";
//		String password = "mpl";

//		Datasou

		InitialContext context;
		try {
			context = new InitialContext();
			DataSource ds = (DataSource) context.lookup("java:comp/env/jdbc/DSTest");

			Connection testConn = ds.getConnection();

			conn = new DBConnection(testConn, "PostgreSQL");

			return conn;

		} catch (NamingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new InternalServerErrorException(e.getMessage());

		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new InternalServerErrorException(e.getMessage());
		}


//		// database URL
//		String M_DB_URL         = "jdbc:postgresql:jena";

//		// User name
//		String M_DB_USER        = "jena";

//		// Password
//		String M_DB_PASSWD      = "jena";

//		// Database engine name
//		String M_DB = "PostgreSQL";

//		// JDBC driver
//		String M_DBDRIVER_CLASS = "org.postgresql.Driver";

//		Class.forName(M_DBDRIVER_CLASS);

//		conn = new DBConnection(M_DB_URL, M_DB_USER, M_DB_PASSWD, M_DB);

//		conn = DriverManager.getConnection(url, user, password);

//		} catch (ClassNotFoundException e) {
//		// TODO Auto-generated catch block
//		e.printStackTrace();
//		return null;	
//		}

//		return conn;
	}
	
	/**
	 * Load the ontology..
	 * @param model
	 * @param fileName
	 */
	public static void loadN3(Model model, String fileName)
	{		
		// use the FileManager to find the input file
		InputStream in = FileManager.get().open( fileName );
		if (in == null) {
			throw new IllegalArgumentException(
					"File: " + fileName + " not found");
		}
		model.read(in, "", "N3");
		
		try {
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
}
