package no.miles.mpl.semantic.app.endpoint.entries;


import java.util.ArrayList;
import java.util.Date;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMFactory;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import no.miles.mpl.wrapper.datastructures.Project;

import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Link;

public class ProjectEntry extends Entry{

	public ProjectEntry(String baseURI, Project project) throws Exception {
		super();

		this.setId(baseURI + project.getName() + "/issues/");
		this.setTitle(project.getName());
		this.setUpdated(new Date());	

		ArrayList<Link> links = new ArrayList<Link>();
		Link link = new Link();
		link.setHref(project.getBugtrackerurl());
		link.setRel("alternate");

		links.add(link);

		Link selfLink = new Link();
		selfLink.setHref(this.getId());
		selfLink.setRel("self");

		links.add(selfLink);	

		this.setAlternateLinks(links);	
		
		ArrayList<Link> otherLinks = new ArrayList<Link>();
		Link edit = new Link();
		edit.setHref(baseURI + project.getName());
		edit.setRel("edit");
		otherLinks.add(edit);
		this.setOtherLinks(otherLinks);
		
		Content summary = new Content();
		summary.setType("text/html");
		summary.setValue("Miles Platform project with bugtracker <a href=\"" + project.getBugtrackerurl() + "\"> "+ project.getBugtrackertype() + "</a>");
		this.setSummary(summary);

		/*
		 * Add config parameters..
		 */
		Content content = new Content();
//		content.setType("application/xml");
	
		

//		Element root = new Element("projectconfig");
//		Document doc = new Document(root);
//
//		Element bugtracker_name = new Element("bugtracker_name");
//		bugtracker_name.setText(project.getBugtrackertype());
//		root.getChildren().add(bugtracker_name);
//
//		Element bugtracker_url = new Element("bugtracker_url");
//		bugtracker_url.setText(project.getBugtrackerurl());
//		root.getChildren().add(bugtracker_url);
//
//
//		Format format = Format.getPrettyFormat();		
//		format.setEncoding("UTF-8");
//		format.setOmitDeclaration(true);
//		format.setOmitEncoding(true);

//		XMLOutputter outputter = new XMLOutputter(format);		
//		String value = outputter.outputString(doc);		
		
		content.setValue(project.toN3());
//		content.setType(Content.XML);
//		content.setType("application/xml");
		content.setType("text/rdf+n3");
		
		this.getContents().add(content);

//		System.out.println(value);


	}

}
