package no.miles.mpl.semantic.app.endpoint.entries;

import java.util.List;

import org.jdom.Element;
import org.jdom.output.XMLOutputter;

import com.sun.syndication.feed.atom.Content;
import com.sun.syndication.feed.atom.Entry;

public class SparqlResultEntry extends Entry {

	public SparqlResultEntry(String id, Element resultElement){

		super();

//		this.setId(id);
		this.setId("sparqlresutl");

		//Add the raw xml to content
		Content content = new Content();		
		XMLOutputter outPutter = new XMLOutputter();		
		content.setValue(outPutter.outputString(resultElement));
		content.setType("application/xml");
		this.getContents().add(content);

		String title = "SparqResult";
		String summary = "";

		StringBuffer summaryBuffer = new StringBuffer();
		
		//Create some useful information for title and summary
		List<Element> bindings = resultElement.getChildren();
		for (Element bindingElement : bindings) {			
			if(bindingElement.getName().equalsIgnoreCase("binding")){
				String varName = bindingElement.getAttributeValue("name");
				Element uriElement = bindingElement.getChild("uri", null);
				if(uriElement != null){				
					String uri = uriElement.getText();				
//					summary += varName + " bound to <a href=\"" + uri + "\">" + uri + "</a><br>";	
					summaryBuffer.append(varName + " bound to <a href=\"" + uri + "\">" + uri + "</a><br>");
				}	
			}
		}

		summary = summaryBuffer.toString();
		
		Content summaryContent = new Content();
		summaryContent.setType("text/html");
		summaryContent.setValue(summary);

		this.setTitle(title);
		this.setSummary(summaryContent);

	}

}
