package no.miles.mpl.semantic.app.endpoint.feeds;

import java.util.ArrayList;
import java.util.Date;

import no.miles.mpl.semant.app.endpoint.datahandlers.Issues;
import no.miles.mpl.semant.app.endpoint.datahandlers.Projects;
import no.miles.mpl.wrapper.datastructures.Project;
import no.miles.mpl.wrapper.exception.BadRequestException;
import no.miles.mpl.wrapper.exception.InternalServerErrorException;

import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Feed;

public class EntryCachedFeed extends Feed {
	
	private String username;
	private String password;

	/**
	 * UriPrefix must be "http://host:port/projects/
	 * @param username
	 * @param password
	 * @param projectName
	 * @param uriPrefix
	 * @throws BadRequestException
	 * @throws InternalServerErrorException
	 */
	public EntryCachedFeed(String username, String password, String projectName, String uriPrefix) throws BadRequestException, InternalServerErrorException{
		super();

		this.username = username;
		this.password = password;

		this.setId(projectName + "/issues/");
		this.setTitle(projectName + " issues");
		this.setUpdated(new Date());		

		try{
			Project project = Projects.getProject(uriPrefix, projectName, username, password);
			
			ArrayList<Entry> entries = Issues.getEntries(username, password, project, uriPrefix);
			
			System.out.println("Fetched " + entries.size());
			
			this.setEntries(entries);
			
			
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			throw new InternalServerErrorException(e.getMessage());
		}
	}

}
