package no.miles.mpl.semantic.app.endpoint.feeds;


import java.util.ArrayList;
import java.util.Date;
import java.util.Properties;

import no.miles.mpl.semant.app.endpoint.datahandlers.Projects;
import no.miles.mpl.semantic.app.endpoint.entries.ProjectEntry;
import no.miles.mpl.wrapper.datastructures.Project;
import no.miles.mpl.wrapper.exception.InternalServerErrorException;

import com.sun.syndication.feed.atom.Entry;
import com.sun.syndication.feed.atom.Feed;

public class ProjectFeed extends Feed {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7660170970391882754L;
	
	Properties projects;

	public ProjectFeed(String baseUrl, String username, String password) throws InternalServerErrorException{
		super();
		
		this.setId(baseUrl + "projects/");
		this.setTitle("Miles Platform projects");
		this.setUpdated(new Date());		
		this.setFeedType("atom_1.0");
		
		
		ArrayList<Project> projects = Projects.getProjects(username, password);
		
		System.out.println("Fetched " + projects.size() + " projects");

		System.out.println("Adding projects..");
		
		this.addProjects(projects);		
		
		System.out.println("Added projects..");
	}


	private void addProjects(ArrayList<Project> projects){

		ArrayList<Entry> entries = new ArrayList<Entry>();

		for (Project project : projects) {
			
			
			
			Entry entry;
			try {
				entry = new ProjectEntry(getId(), project);
				entries.add(entry);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}



		}

		this.setEntries(entries);


	}





}
