import java.util.List;

import junit.framework.TestCase;
import no.miles.mpl.semantic.app.endpoint.feeds.IssueSparqlResultFeed;

import org.junit.Test;

import com.sun.syndication.feed.atom.Entry;



public class SparqlFeedTest extends TestCase {

	public static boolean runIntegrationTests = false;

	@Test
	public void testSparqlQuery() throws Exception {

		if(runIntegrationTests){

			String sparqlQuery = 		
				"PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#> " +
				"PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#> " +
				"PREFIX owl:  <http://www.w3.org/2002/07/owl#> " +
				"PREFIX baetle: <" + IssueSparqlResultFeed.BAETLENS +"> " +
				"PREFIX foaf: <" + IssueSparqlResultFeed.FOAFNS +"> " +
				"PREFIX doap: <" + IssueSparqlResultFeed.DOAPNS +"> " +
				"PREFIX sioc: <" + IssueSparqlResultFeed.SIOCNS +"> " +
				"PREFIX wf: <" + IssueSparqlResultFeed.WFNS +"> " +
				"SELECT ?issue " +
				"WHERE {" +
				"      ?issue rdf:type baetle:Issue . " +
				"      ?priority rdf:type baetle:Critical . " +
				"      ?issue baetle:priority ?priority . " +
				"      }";	

			System.out.println(sparqlQuery);


			IssueSparqlResultFeed sparqlResultFeed = new IssueSparqlResultFeed("test", "test","LC","http://localhost:8070/no.miles.mpl.semantic.app.endpoint/",sparqlQuery);

			List<Entry> entries = sparqlResultFeed.getEntries();
			for (Entry entry : entries) {
				System.out.println(entry.getSummary().getValue());
			}

		}


	}

}
