package no.miles.mpl.wrapper;

import java.net.URL;
import java.util.ArrayList;
import java.util.Date;

import no.miles.mpl.wrapper.datastructures.Comment;
import no.miles.mpl.wrapper.datastructures.Issue;
import no.miles.mpl.wrapper.exception.BadRequestException;
import no.miles.mpl.wrapper.exception.InternalServerErrorException;
import no.miles.mpl.wrapper.exception.UnAuthorizedException;

public interface BugTrackerWrapperInterface {
	
	public Issue getIssue(String username, String password, String projectKey, String issueKey) throws BadRequestException, InternalServerErrorException;
//	public Project getProject(String username, String password, String project);	
	public Issue[] getIssues(String username, String password, String projectKey) throws BadRequestException, InternalServerErrorException;
	public Issue addIssue(String username, String password, String projectKey, Issue issue) throws BadRequestException, InternalServerErrorException;
	public Issue updateIssue(String username, String password, String projectKey, Issue issue) throws BadRequestException, InternalServerErrorException;
	public void deleteIssue(String username, String password, String projectKey, String issueKey) throws BadRequestException, InternalServerErrorException;

	public Comment[] getComments(String username, String password, String projectKey, String issueKey) throws BadRequestException, InternalServerErrorException;
	public void addComment(String username, String password, String projectKey, String issueKey, Comment comment) throws BadRequestException, InternalServerErrorException;
	
//	public Attachment[] getAttachements(String username, String password, String projectKey, String issueKey);
//	public void addAttachment(String username, String password, String projectKey, String issueKeyt, Attachment attachment, byte[] bytes);
	
	public String[] getComponentNames(String username, String password, String projectKey) throws BadRequestException, InternalServerErrorException;
	public String[] getIssueTypes(String username, String password, String projectKey);
	public String[] getVersions(String username, String password, String projectKey) throws BadRequestException, InternalServerErrorException;
	public String[] getPriorities(String username, String password, String projectKey);
	public String[] getStates(String username, String password, String projectKey, String issueKey);

	public ArrayList<String> getUpdatedIssueKeys(String username, String password, String projectKey, Date date) throws UnAuthorizedException, InternalServerErrorException;
	public ArrayList<String> getIssueKeys(String username, String password, String projectKey) throws UnAuthorizedException, InternalServerErrorException;
	
}
