package no.miles.mpl.wrapper.datastructures;

import java.util.ArrayList;

public class IssueStates extends ArrayList<String> {

	public static final String STATE_OPEN = "http://xmlns.com/baetle/#Open";
	public static final String STATE_NEW = "http://xmlns.com/baetle/#New";
	public static final String STATE_UNCONFIRMED = "http://xmlns.com/baetle/#Unconfirmed";
	public static final String STATE_STARTED = "http://xmlns.com/baetle/#Started";
	public static final String STATE_REOPENED = "http://xmlns.com/baetle/#Reopened";
	public static final String STATE_RESOLVED = "http://xmlns.com/baetle/#Resolved";
	public static final String STATE_NOT_REPRODUCIBLE = "http://xmlns.com/baetle/#NotReproducible";
	public static final String STATE_WORKS_FOR_ME = "http://xmlns.com/baetle/#WorksForMe";
	public static final String STATE_WONT_FIX = "http://xmlns.com/baetle/#WontFix";
	public static final String STATE_INCOMPLETE = "http://xmlns.com/baetle/#Incomplete";
	public static final String STATE_FIXED = "http://xmlns.com/baetle/#Fixed";
	public static final String STATE_LATER = "http://xmlns.com/baetle/#Later";
	public static final String STATE_REMIND = "http://xmlns.com/baetle/#Remind";
	public static final String STATE_DUPLICATE = "http://xmlns.com/baetle/#Duplicate";
	public static final String STATE_VERIFIED = "http://xmlns.com/baetle/#Verified";
	public static final String STATE_CLOSED = "http://xmlns.com/baetle/#Closed";	

	public static final String STATE_STATE = "http://www.w3.org/2005/01/wf/flow#State";
	public static final String STATE_TERMINAL_STATE = "http://www.w3.org/2005/01/wf/flow#TerminalState";
	public static final String STATE_NON_TERMINAL_STATE = "http://www.w3.org/2005/01/wf/flow#NonTerminalState";

	private static IssueStates instance = null;

	protected IssueStates() {
		//TODO: Load automatically from baetle??	

		this.add(STATE_CLOSED);
		this.add(STATE_DUPLICATE);
		this.add(STATE_FIXED);
		this.add(STATE_INCOMPLETE);
		this.add(STATE_LATER);
		this.add(STATE_NEW);
		this.add(STATE_NON_TERMINAL_STATE);
		this.add(STATE_NOT_REPRODUCIBLE);
		this.add(STATE_OPEN);
		this.add(STATE_REMIND);
		this.add(STATE_REOPENED);
		this.add(STATE_RESOLVED);
		this.add(STATE_STARTED);
		this.add(STATE_STATE);
		this.add(STATE_TERMINAL_STATE);
		this.add(STATE_UNCONFIRMED);
		this.add(STATE_VERIFIED);
		this.add(STATE_WONT_FIX);
		this.add(STATE_WORKS_FOR_ME);

	}
	public static IssueStates getInstance() {
		if(instance == null) {
			instance = new IssueStates();
		}
		return instance;
	}


	public String[] getArray() {

		String[] states = new String[this.size()];
		
		for(int i = 0; i < this.size(); i++){
			
			states[i] = this.get(i);
			
		}
		
		return states;

	}

}
