import org.junit.Test;

import no.miles.mpl.wrapper.datastructures.Comment;
import junit.framework.TestCase;


public class CommentTest extends TestCase{
	
	private Comment getDefaultComment(){
		
		return new Comment("test", "this is a new comment..");			
		
	}
	
	@Test
	public void testCommentToN3(){
		
		Comment comment = getDefaultComment();
		String n3 = comment.toN3();
		
		System.out.println("To n3: \n" + n3);
		
	}

	@Test
	public void testParseComment(){
		
		Comment comment = getDefaultComment();
		String n3 = comment.toN3();
		
		try {
			Comment parsedComment = Comment.parseN3(n3);
			
			assertEquals(comment.getAuthor(), parsedComment.getAuthor());
			assertEquals(comment.getContent(), parsedComment.getContent());
			assertEquals(comment.getCreated(), parsedComment.getCreated());
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			fail("Failed parsing comment: " + e.getMessage());
		}
		
	}
	
}
