import java.util.ArrayList;
import java.util.Date;

import junit.framework.TestCase;
import no.miles.mpl.wrapper.datastructures.Issue;
import no.miles.mpl.wrapper.datastructures.IssueTypes;
import no.miles.mpl.wrapper.datastructures.PriorityTypes;

import org.junit.Test;


public class IssueTest extends TestCase {

	private Issue createDefaultIssue() throws Exception
	{
		Issue issue = new Issue();
		issue.setProjectkey("RESTFULLAYER");
		issue.setKey("1");
		issue.setPriority(PriorityTypes.PRIORITY_BLOCKER);
		issue.setType(IssueTypes.ISSUE_TYPE_ENHANCEMENT);
		issue.setSummary("new summary");
		issue.setCreated(new Date());
		issue.setReported_by("test");
		issue.setAssigned_to("test");

		ArrayList<String> components = new ArrayList<String>();
		components.add("Comp1");
		components.add("Comp2");
		issue.setComponents(components);

		ArrayList<String> versions = new ArrayList<String>();
		versions.add("Version1");
		versions.add("Version2");
		issue.setVersions(versions);
		
		issue.setUpdated(new Date());

		issue.setDescription("description");
		issue.setViewissueurl("http://localhost:8080/jira/browse/RESTFULLAYER-1");
		return issue;
	}

	@Test
	public void testParseOntology() throws Exception {

		Issue issue = createDefaultIssue();
		
		issue.setViewissueurl("http://localhost:8090/trac/mpl/ticket/12");
		
		String ontology = issue.toN3();
		
//		System.out.println("ont: " + ontology);

		Issue parsedIssue;
		
//		parsedIssue = Issue.parseOntology(ontology, issue.getProjectkey(), issue.getKey(), issue.getViewissueurl());

		parsedIssue = Issue.parseOntology(ontology, issue.getProjectkey());

		assertEquals(issue.getType(), parsedIssue.getType());
		assertEquals(issue.getPriority(), parsedIssue.getPriority());
//		assertEquals(issue.getKey(), parsedIssue.getKey());
		assertEquals(issue.getProjectkey(), parsedIssue.getProjectkey());
		assertEquals(issue.getSummary(), parsedIssue.getSummary());

//		fail("Not yet implemented");

	}

	@Test
	public void testParseXml() throws Exception {




//		fail("Not yet implemented");

	}

	@Test
	public void testToN3() throws Exception {

		Issue issue = createDefaultIssue();

		String ontology = issue.toN3();

//		fail("Not yet implemented");

	}

	@Test
	public void testToXml() {

//		fail("Not yet implemented");

	}

}
