package no.miles.mpl.tracapi;


import java.util.Date;
import java.util.Map;

public interface Ticket
{
	/**
	 * Get the changelog
	 * @param id
	 * @return
	 */
//	Object[] changeLog(int id, int when);
	Object[] changeLog(int id, int when);
	
	/**
	 * Get all version names
	 * @return
	 */
	Object[] version_getAll() throws Exception;
	
	
	/**
	 * Get all component names
	 * @return
	 */
	Object[] component_getAll();
	
    
    /**
     * Fetch a ticket.
     * 
     * @param id Ticket id
     * @return [id, time_created, time_changed, attributes]
     */
    Object[] get( int id ) throws Exception;
    
    /**
     * Delete ticket with the given id.
     * 
     * @param id
     * @return ??
     */
    int delete( int id ) throws Exception;
    
    
    
    
    /**
     * Perform a ticket query, returning a list of ticket ID's.
     * 
     * @param query
     * @return an array of ticket ids.
     */
    Object[] query( String query ) throws Exception;
    
    /**
     * Create a new ticket, returning the ticket ID.
     * 
     * @param summary Summary of the ticket
     * @param description Ticket Description
     * @param attributes A map containing the ticket attributes
     * @return the newly created ticket id  
     */
    int create( String summary, String description, Map<String,String> attributes ) throws Exception;    
    
    /**
     * Update a ticket
     * @param id
     * @param comment
     * @param attributes A map containing the ticket attributes
     * @return
     */
    Object[] update(int id, String comment, Map<String,String> attributes) throws Exception;
    
    
    Object[] getRecentChanges(Date since);
    
}
