package no.miles.mpl.atomextension.issue;

import java.util.List;

import org.jdom.Element;
import org.jdom.Namespace;

import com.sun.syndication.feed.module.Module;
import com.sun.syndication.io.ModuleParser;

public class IssueModuleParser implements ModuleParser {

	private static final Namespace ISSUE_NS  = Namespace.getNamespace("mplissue", IssueModule.URI);

	@Override
	public String getNamespaceUri() {
		// TODO Auto-generated method stub
		return IssueModule.URI;
	}

	@Override
	public Module parse(Element dcRoot) {
		// TODO Auto-generated method stub
		boolean foundSomething = false;

		IssueModule im = new IssueModuleImpl();

		Element e = dcRoot.getChild("assigned_to", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setAssignedTo(e.getText());
		}

		List<Element> eList = dcRoot.getChildren("component", ISSUE_NS);
		if (eList != null) {
			foundSomething = true;
			for (Element element : eList) {
				im.getComponents().add(element.getText());
			}
		}

		e = dcRoot.getChild("description", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setDescription(e.getText());
		}

		e = dcRoot.getChild("priority", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setPriority(e.getText());
		}

		e = dcRoot.getChild("reported_by", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setReportedBy(e.getText());
		}

		e = dcRoot.getChild("resolution", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setResolution(e.getText());
		}

		e = dcRoot.getChild("reported_by", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setReportedBy(e.getText());
		}

		e = dcRoot.getChild("status", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setStatus(e.getText());
		}

		e = dcRoot.getChild("type", ISSUE_NS);
		if (e != null) {
			foundSomething = true;
			im.setType(e.getText());
		}

		eList = dcRoot.getChildren("version", ISSUE_NS);
		if (eList != null) {
			foundSomething = true;

			for (Element element2 : eList) {
				im.getVersions().add(element2.getText());
			}
		}

		return (foundSomething) ? im : null;
	}

}
