package no.miles.mpl.atomextension.projects;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import org.jdom.Element;
import org.jdom.Namespace;

import com.sun.syndication.feed.module.Module;
import com.sun.syndication.io.ModuleGenerator;

public class ProjectsModuleGenerator implements ModuleGenerator {

	 private static final Namespace PROJECTS_NS  = Namespace.getNamespace("mplprojects", ProjectsModule.URI);

	@Override
	public void generate(Module module, Element element) {

		// this is not necessary, it is done to avoid the namespace definition in every item.
        Element root = element;
        while (root.getParent()!=null && root.getParent() instanceof Element) {
            root = (Element) element.getParent();
        }
        root.addNamespaceDeclaration(PROJECTS_NS);

        ProjectsModule pm = (ProjectsModule)module;
        if (pm.getBugtrackerName() != null) {
            element.addContent(generateSimpleElement("bugtrackername", pm.getBugtrackerName()));
        }

        if (pm.getBugtrackerUrl() != null) {
            element.addContent(generateSimpleElement("bugtrackerurl", pm.getBugtrackerUrl()));
        }
	}
	
	private static final Set NAMESPACES;
	
    static {
        Set nss = new HashSet();
        nss.add(PROJECTS_NS);
        NAMESPACES = Collections.unmodifiableSet(nss);
    }

	@Override
	public String getNamespaceUri() {
		// TODO Auto-generated method stub
		return ProjectsModule.URI;
	}

	@Override
	public Set getNamespaces() {
		// TODO Auto-generated method stub
		return NAMESPACES;
	}
	
    protected Element generateSimpleElement(String name, String value)  {
        Element element = new Element(name, PROJECTS_NS);
        element.addContent(value);
        return element;
    }
	
}
