package no.miles.mpl.semantic.restfulendpoint;


import org.restlet.Application;
import org.restlet.Component;
import org.restlet.Context;
import org.restlet.Restlet;
import org.restlet.Router;
import org.restlet.data.Protocol;

public class RestApplication extends Application {

	public static void main(String... args) throws Exception {
		
		// Create a component with an HTTP server connector
		Component comp = new Component();
		comp.getServers().add(Protocol.HTTP, 9092);	  
//		comp.getClients().add(Protocol.FILE);
		comp.getDefaultHost().attach("", new RestApplication(comp.getContext()));
		comp.start();			
	}

	public RestApplication()
	{
		super();
	}

	public RestApplication(Context context) {
		super(context);
	}

	@Override
	public Restlet createRoot() {

		Router router = new Router(getContext());
		
//		router.attach("/xsd/", Xsd.class);
//		
		router.attach("/projects/{project}/", RestProject.class);
//
		router.attach("/projects/{project}/issues/", RestIssues.class);
//
		router.attach("/projects/{project}/issues/{issue}/", RestIssue.class);
//
//		router.attach("/projects/{project}/config/", Config.class);

		return router;
	}



}
