package no.miles.mpl.semantic.restfulendpoint;

import java.io.ByteArrayOutputStream;

import no.miles.mpl.semantic.AtomToBaetleConverter;
import no.miles.mpl.semantic.SparqlQuery;

import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.resource.DomRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.StringRepresentation;
import org.restlet.resource.Variant;

import com.hp.hpl.jena.rdf.model.Model;

public class RestIssue extends RestIssues{

	protected String issueKey;

	public RestIssue(Context context, Request request, Response response) {
		super(context, request, response);
		this.issueKey = (String) request.getAttributes().get("issue");	

		

		getVariants().add(new Variant(MediaType.TEXT_PLAIN));
		getVariants().add(new Variant(MediaType.TEXT_XML));
	}

	@Override
	public Representation getRepresentation(Variant variant) {
		Representation result = null;

		System.out.println(variant.getMediaType().toString());

		


			if(query != null && query.toLowerCase().startsWith("sparql"))
			{
//				result = new StringRepresentation(select());		
				
//				variant.setMediaType(MediaType.TEXT_XML);
				
				result = new StringRepresentation(sparqlSelect());
			}
			else
			{
				Model describeModel = describe();				
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				describeModel.write(out);
				result = new StringRepresentation(out.toString());
			}

//			System.out.println(sparqlResult);
//			result = new StringRepresentation("hei..");

		return result;
	}

	
	private Model describe()
	{
		String queryString = 		
			"PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>" +
			"PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>" +
			"PREFIX owl:  <http://www.w3.org/2002/07/owl#>" +
			"PREFIX mpl: <" + AtomToBaetleConverter.nsMpl + ">" +
			"PREFIX foaf: <" + AtomToBaetleConverter.nsFoaf +">" +
			"PREFIX doap: <" + AtomToBaetleConverter.nsDoap +">" +
			"PREFIX sioc: <" + AtomToBaetleConverter.nsSioc +">" +
			"PREFIX wf: <" + AtomToBaetleConverter.nsWorkFlow +">" +
			"DESCRIBE ?issue " +
			"WHERE {" +
			"      ?issue rdf:type mpl:Issue . " +
			" 	   ?issue mpl:hasKey \"" + issueKey + "\" . " +		
			"      }";	
		
		Model describeModel = SparqlQuery.describe(inf, queryString);
		
		return describeModel;
	}

}
