package no.miles.mpl.semantic.restfulendpoint;

import java.io.ByteArrayOutputStream;

import no.miles.mpl.semantic.AtomConverter;
import no.miles.mpl.semantic.AtomToBaetleConverter;
import no.miles.mpl.semantic.SparqlQuery;

import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Reference;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.resource.Representation;
import org.restlet.resource.Resource;
import org.restlet.resource.StringRepresentation;
import org.restlet.resource.Variant;

import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.rdf.model.Model;

public class RestIssues extends RestProject{



	/**
	 * Constructor
	 * @param context
	 * @param request
	 * @param response
	 */
	public RestIssues(Context context, Request request, Response response) {
		super(context, request, response);
		


//		m.write(System.out, "RDF/XML-ABBREV");	

	}
	

	private Model describe()
	{
		String queryString = 		
			"PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>" +
			"PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>" +
			"PREFIX owl:  <http://www.w3.org/2002/07/owl#>" +
			"PREFIX mpl: <" + AtomToBaetleConverter.nsMpl + ">" +
			"PREFIX foaf: <" + AtomToBaetleConverter.nsFoaf +">" +
			"PREFIX doap: <" + AtomToBaetleConverter.nsDoap +">" +
			"PREFIX sioc: <" + AtomToBaetleConverter.nsSioc +">" +
			"PREFIX wf: <" + AtomToBaetleConverter.nsWorkFlow +">" +
			"DESCRIBE ?issue " +
			"WHERE {" +
			"      ?issue rdf:type mpl:Issue . " +	
			"      }";	

		Model describeModel = SparqlQuery.describe(inf, queryString);

		return describeModel;
	}



	@Override
	public Representation getRepresentation(Variant variant) {
		Representation result = null;

		if(variant.getMediaType().equals(MediaType.TEXT_PLAIN)){


			if(query != null && query.toLowerCase().startsWith("sparql"))
			{
				result = new StringRepresentation(sparqlSelect());
			}
			else
			{
				Model describeModel = describe();
				ByteArrayOutputStream out = new ByteArrayOutputStream();
				describeModel.write(out);
				result = new StringRepresentation(out.toString());
			}
		}

		else {
			result = new StringRepresentation("Du ba om " + variant.getMediaType().toString());
		}

		return result;
	}


	@Override
	public void handleGet() {
		// Make sure that the Uri ends with a "/" without changing the query.
		Reference ref = getRequest().getResourceRef();
		if (!ref.getPath().endsWith("/")) {
			ref.setPath(ref.getPath() + "/");
			getResponse().redirectPermanent(ref);
		} else {
			super.handleGet();
		}
	}
}
