package no.miles.mpl.semantic;

import com.hp.hpl.jena.query.Query;
import com.hp.hpl.jena.query.QueryExecution;
import com.hp.hpl.jena.query.QueryExecutionFactory;
import com.hp.hpl.jena.query.QueryFactory;
import com.hp.hpl.jena.query.ResultSet;
import com.hp.hpl.jena.query.ResultSetFormatter;
import com.hp.hpl.jena.rdf.model.Model;

public class SparqlQuery {
 

	/**
	 * Executes a sparql query on the supplied model
	 * @param model
	 * @param queryString
	 */
	public static void performQuery(Model model, String queryString)
	{
		Query query = QueryFactory.create(queryString);

		// Execute the query and obtain results
		QueryExecution qe = QueryExecutionFactory.create(query, model);
		ResultSet rs = qe.execSelect();
		
		// Output query results			

		// Important - free up resources used running the query

		ResultSetFormatter.out(System.out, rs);
		qe.close();
	
	}
}
