            
class ProjectController {
    
    def index = { redirect(action:list,params:params) }

    // the delete, save and update actions only accept POST requests
    def allowedMethods = [delete:'POST', save:'POST', update:'POST']

    def list = {
        if(!params.max) params.max = 10
        [ projectList: Project.list( params ) ]
    }

    def show = {
    
    	print params
    
        def project = Project.get( params.id )

        if(!project) {
            flash.message = "Project not found with key ${params.id}"
            redirect(action:list)
        }
        else { return [ project : project ] }
    }

    def delete = {
    	
    	print params
    
        def project = Project.get( params.id )
        if(project) {
            project.delete()
            flash.message = "Project ${params.id} deleted"
            redirect(action:list)
        }
        else {
            flash.message = "Project not found with key ${params.id}"
            redirect(action:list)
        }
    }

    def edit = {
    
    	print "edit with params " + params
    
        def project = Project.get( params.id )

        if(!project) {
            flash.message = "Project not found with id ${params.id}"
            redirect(action:list)
        }
        else {
            return [ project : project ]
        }
    }

    def update = {
        def project = Project.get( params.id )
        if(project) {
        	
        	print "updating project " + params
        
            //project.properties = params
            
            project.bugtrackerUrl = params.bugtrackerUrl
            project.bugtrackerName = params.bugtrackerName
            
            print "new bugtrackername " + project.bugtrackerName
            
            if(!project.hasErrors() && project.save()) {
                flash.message = "Project ${params.id} updated"
                redirect(action:show,id:project.key)
            }
            else {
                render(view:'edit',model:[project:project])
            }
        }
        else {
            flash.message = "Project not found with key ${params.id}"
            redirect(action:edit,key:params.key)
        }
    }

    def create = {
        def project = new Project()
        //project.properties = params
        return ['project':project]
    }

    def save = {
    
    	print params
    
        def project = new Project(key:params.key, bugtrackerName:params.bugtrackerName, bugtrackerUrl:params.bugtrackerUrl)
        
        if(!project.hasErrors() && project.save()) {
            flash.message = "Project ${project.key} created"
            redirect(action:show,id:project.key)
        }
        else {
            render(view:'create',model:[project:project])
        }
    }
}