            
class ProjectFeedController {
    
    def index = { redirect(action:list,params:params) }

    // the delete, save and update actions only accept POST requests
    def allowedMethods = [delete:'POST', save:'POST', update:'POST']

    def list = {
        if(!params.max) params.max = 10
        [ projectFeedList: ProjectFeed.list( params ) ]
    }

    def show = {
        def projectFeed = ProjectFeed.get( params.id )

        if(!projectFeed) {
            flash.message = "ProjectFeed not found with id ${params.id}"
            redirect(action:list)
        }
        else { return [ projectFeed : projectFeed, projectList: Project.list( params ) ] }
    }

    def delete = {
        def projectFeed = ProjectFeed.get( params.id )
        if(projectFeed) {
            projectFeed.delete()
            flash.message = "ProjectFeed ${params.id} deleted"
            redirect(action:list)
        }
        else {
            flash.message = "ProjectFeed not found with id ${params.id}"
            redirect(action:list)
        }
    }

    def edit = {
        def projectFeed = ProjectFeed.get( params.id )

        if(!projectFeed) {
            flash.message = "ProjectFeed not found with id ${params.id}"
            redirect(action:list)
        }
        else {
            return [ projectFeed : projectFeed ]
        }
    }

    def update = {
        def projectFeed = ProjectFeed.get( params.id )
        if(projectFeed) {
            projectFeed.properties = params
            if(!projectFeed.hasErrors() && projectFeed.save()) {
                flash.message = "ProjectFeed ${params.id} updated"
                redirect(action:show,id:projectFeed.id)
            }
            else {
                render(view:'edit',model:[projectFeed:projectFeed])
            }
        }
        else {
            flash.message = "ProjectFeed not found with id ${params.id}"
            redirect(action:edit,id:params.id)
        }
    }

    def create = {
        def projectFeed = new ProjectFeed()
        projectFeed.properties = params
        return ['projectFeed':projectFeed]
    }

    def save = {
        def projectFeed = new ProjectFeed(params)
        if(!projectFeed.hasErrors() && projectFeed.save()) {
            flash.message = "ProjectFeed ${projectFeed.id} created"
            redirect(action:show,id:projectFeed.id)
        }
        else {
            render(view:'create',model:[projectFeed:projectFeed])
        }
    }
}